#include <windows.h> 
#include "coproc.h"
#include "gpio.h"
#include "spi.h"
#define DURATION_FOR_WAVEFORM 500																								///< Loop for generating wave for certain time
typedef enum {
	SINE_WAVE		= 'a',
	SQUARE_WAVE		= 'b',
	SAW_WAVE		= 'c',
	TRAINGLE_WAVE	= 'd',
	EXIT_OPTION		= 'e'
}option;	

DWORD sineWave[129] = {	0x63, 0x38, 0x2B, 0x39, 0xF1, 0x39, 0xB1, 0x3A, 0x6A, 0x3B, 0x1C, 0x3C, 0xC3, 0x3C, 0x5E, 0x3D,
						0xEC, 0x3D, 0x6C, 0x3E, 0xDB, 0x3E, 0x3A, 0x3F, 0x87, 0x3F, 0xC1, 0x3F, 0xE8, 0x3F, 0xFC, 0x3F, 
						0xFC, 0x3F, 0xE8, 0x3F, 0xC1, 0x3F, 0x87, 0x3F, 0x3A, 0x3F, 0xDB, 0x3E, 0x6C, 0x3E, 0xEC, 0x3D, 
						0x5E, 0x3D, 0xC3, 0x3C, 0x1C, 0x3C, 0x6A, 0x3B, 0xB1, 0x3A, 0xF1, 0x39, 0x2B, 0x39, 0x63, 0x38, 
						0x9B, 0x37, 0xD3, 0x36, 0x0D, 0x36, 0x4D, 0x35, 0x94, 0x34, 0xE2, 0x33, 0x3B, 0x33, 0xA0, 0x32, 
						0x12, 0x32, 0x92, 0x31, 0x23, 0x31, 0xC4, 0x30, 0x77, 0x30, 0x3d, 0x30, 0x16, 0x30, 0x02, 0x30, 
						0x02, 0x30, 0x16, 0x30, 0x3D, 0x30, 0x77, 0x30, 0xC4, 0x30, 0x23, 0x31, 0x92, 0x31, 0x12, 0x32, 
						0xA0, 0x32, 0x3B, 0x33, 0xE2, 0x33, 0x94, 0x34, 0x4D, 0x35, 0x0D, 0x36, 0xD3, 0x36, 0x9B, 0x37,
						0x00};																									///< SineWave data value 

DWORD sawWave[69] =	 {	0x01, 0x30, 0x7D, 0x30, 0xFA, 0x30, 0x77, 0x31, 0xF4, 0x31, 0x71, 0x32, 0xEE, 0x32, 0x6B, 0x33,
						0xE8, 0x33, 0x65, 0x34, 0xE2, 0x34, 0x5F, 0x35, 0xDC, 0x35, 0x59, 0x36, 0xD6, 0x36, 0x53, 0x37, 
						0xD0, 0x37, 0x4D, 0x38, 0xCA, 0x38, 0x47, 0x39, 0xC4, 0x39, 0x41, 0x3A, 0xBE, 0x3A, 0x3B, 0x3B,
						0xB8, 0x3B, 0x35, 0x3C, 0xB2, 0x3C, 0x2F, 0x3D, 0xAC, 0x3D, 0x29, 0x3E, 0xA6, 0x3E, 0x23, 0x3F,	
						0xA0, 0x3F, 0x01, 0x30, 0x00};																			///< Saw Wave data Value

DWORD triangleWave[131]={0x01, 0x30, 0x7D, 0x30, 0xFA, 0x30, 0x77, 0x31, 0xF4, 0x31, 0x71, 0x32, 0xEE, 0x32, 0x6B, 0x33, 
						0xE8, 0x33, 0x65, 0x34, 0xE2, 0x34, 0x5F, 0x35, 0xDC, 0x35, 0x59, 0x36, 0xD6, 0x36, 0x53, 0x37, 
						0xD0, 0x37, 0x4D, 0x38, 0xCA, 0x38, 0x47, 0x39, 0xC4, 0x39, 0x41, 0x3A, 0xBE, 0x3A, 0x3B, 0x3B, 
						0xB8, 0x3B, 0x35, 0x3C, 0xB2, 0x3C, 0x2F, 0x3D, 0xAC, 0x3D, 0x29, 0x3E, 0xA6, 0x3E, 0x23, 0x3F, 
						0xA0, 0x3F, 0x23, 0x3F, 0xA6, 0x3E, 0x29, 0x3E, 0xAC, 0x3D, 0x2F, 0x3D, 0xB2, 0x3C, 0x35, 0x3C, 
						0xB8, 0x3B, 0x3B, 0x3B, 0xBE, 0x3A, 0x41, 0x3A, 0xC4, 0x39, 0x47, 0x39, 0xCA, 0x38, 0x4D, 0x38, 
						0xD0, 0x37, 0x53, 0x37, 0xD6, 0x36, 0x59, 0x36, 0xDC, 0x35, 0x5F, 0x35, 0xE2, 0x34, 0x65, 0x34, 
						0xE8, 0x33, 0x6B, 0x33, 0xEE, 0x32, 0x71, 0x32, 0xF4, 0x31, 0x77, 0x31, 0xFA, 0x30, 0x7D, 0x30,
						0x01, 0x30, 0x00};																						///< Triangle Wave data Value

DWORD squareWave[6] =   {0xd9, 0x34, 0x01, 0x30, 0x00};																			///< Square Wave data value

///< Write Wave form digital data value to DAC chip over SPI and generate corresponding waveform
BOOL generateWaveForm(HANDLE spi, DWORD *waveFormValue, DWORD loopCounter, DWORD size)
{
	DWORD	loopCount	= 0;
	DWORD   spiData[3]	= {0};
	DWORD	dataCount   = 0;
	DWORD	returnValue = 0;
	if(spi == NULL)
	{
		return FALSE;
	}
	while(loopCount < loopCounter)
	{
		for (dataCount = 0; dataCount < size; dataCount = dataCount+2)
		{
			spiData[1] = waveFormValue[dataCount];
			spiData[0] = waveFormValue[dataCount+1];									///< Prepare buffer to transmit over SPI
			returnValue = Spi_Write(spi, spiData, 2);									///< Write 2 frame over SPI
			if(returnValue == 0)
			{
				printf("\nError in sending data\n");
			}
		}
		loopCount++;
	}


	return TRUE;
}

int wmain()
{
	DWORD		spiFrameBit = 0;
	DWORD		clockSet = 26000;														///< SPI clock
	CHAR		choice	 = ' ';															///< Console menu option selection
	HANDLE		hSPI	 = NULL;														///< Handle to SPI library													
	tVersion	ver;																	///< Library version
	Spi_GetVersion(&ver);																///< Get Library Version
	wprintf(L"Demo Application for the SPI\nLibrary version V%d.%d.%d\r\n", ver.Major, ver.Minor, ver.Build);
	hSPI = Spi_Init(L"SPI2");															///< Init SPI interface
	if (!hSPI)
	{
		wprintf(L"Error initializing the SPI Library\r\n");
	}
	Spi_SetConfigInt(hSPI, L"SpiMode",SpiMode0, StoreVolatile);							///< Set SPI MODE of operation
	Spi_SetConfigInt(hSPI, L"BitRateHz", clockSet, StoreVolatile);						///< Set SPI clock speed
	if (!Spi_Open(hSPI))																///< Open SPI interface
	{
		wprintf(L"Failed to open SPI\r\n");
		return 0;
	}
	Spi_SetConfigInt(hSPI, L"ioCS", 86, StoreVolatile);									///< Set Chip Select to sodimm 86
	while(choice != EXIT_OPTION)
	{
		fflush(stdin);
		printf("\nSelect Option\na.) Sine wave\nb.) Square wave\nc.) Sawtooth\nd.) Triangle wave\ne.) Exit\n");
		scanf_s("%c", &choice);
		switch(choice)
		{
		case SINE_WAVE:
			generateWaveForm(hSPI, sineWave, DURATION_FOR_WAVEFORM, 128);				///< Sine Wave 
			break;
		case SQUARE_WAVE:
			generateWaveForm(hSPI, squareWave, DURATION_FOR_WAVEFORM, 4);				///< Square Wave
			break;
		case SAW_WAVE:
			generateWaveForm(hSPI, sawWave, DURATION_FOR_WAVEFORM, 68);					///< Saw Wave
			break;
		case TRAINGLE_WAVE:
			generateWaveForm(hSPI, triangleWave, DURATION_FOR_WAVEFORM, 130);			///< Traingle Wave
			break;
		case EXIT_OPTION:
			Spi_Close(hSPI);															///< De-Initialize SPI
			Spi_Deinit(hSPI);
			wprintf(L"Closing Demo.....");
			Sleep(2000);
			break;
		default:
			printf("Invalid option\n\n");
			break;
		}
	}
	return 0;
}

	